package edu.wpi.appjudicator.ssl;

public class SSL_Helper {
    public static int convert_to_int (byte[] bytes, int start, int len) {
        int end = start + len - 1;
        int temp = 1;
        int result = 0;
        while (end >= start) {
            result += (0xff&bytes[end]) * temp;
            temp *= 256;
            end -= 1;
        }
        return result;
    }

    public static void revert_to_bytes(int number, byte[] dst, int start, int len) {
        int end = start + len - 1;
        int mask = 0xff;
        int temp = number;
        while (end >= start) {
            dst[end] = (byte) (temp & mask);
            end -= 1;
            temp = temp >> 8;
        }
    }

    public static void revert_to_bytes(long number, byte[] dst, int start, int len) {
        int end = start + len - 1;
        int mask = 0xff;
        long temp = number;
        while (end >= start) {
            dst[end] = (byte) (temp & mask);
            end -= 1;
            temp = temp >> 8;
        }
    }

    public static int castToInt(byte b) {
        return b & 0xff;
    }

    public static int  castToInt(short s) {
        return s & 0xffff;
    }

    private static final char[] HEX_ARRAY = "0123456789ABCDEF".toCharArray();
    public static String bytesToHex(byte[] bytes) {
        char[] hexChars = new char[bytes.length * 2];
        for (int j = 0; j < bytes.length; j++) {
            int v = bytes[j] & 0xFF;
            hexChars[j * 2] = HEX_ARRAY[v >>> 4];
            hexChars[j * 2 + 1] = HEX_ARRAY[v & 0x0F];
        }
        return new String(hexChars);
    }

    public static boolean compareByteArrays(byte[] a1, byte[] a2) {
        if (a1.length != a2.length) {return  false;}
        for (int i = 0; i < a1.length; ++ i) {
            if (a1[i] != a2[i]) {
                return false;
            }
        }
        return true;
    }

    public static boolean compareByteArrays(byte[] a1, byte[] a2, int len) {
        for (int i = 0; i < len; ++ i) {
            if (a1[i] != a2[i]) {
                return false;
            }
        }
        return true;
    }
}
