package edu.wpi.appjudicator.ssl.tls_packet_parsing;

public class TLS_Alert_Message implements TLS_Sublayer {
    byte alert_level;
    byte alert_description;

    TLS_Alert_Message(byte[] raw_data, int start, int len) {
        this.alert_level = raw_data[0];
        this.alert_description = raw_data[1];
    }

    TLS_Alert_Message(TLS_Alert_Message_Builder b) {
        this.alert_level = b.alert_level;
        this.alert_description = b.alert_description;
    }


    @Override
    public byte[] getRawData() {
        byte[] rd = new byte[2];
        rd[0] = this.alert_level;
        rd[1] = this.alert_description;
        return rd;
    }

    @Override
    public int getTotalSize() {
        return 2;
    }

    public static class TLS_Alert_Message_Builder implements TLS_Builder<TLS_Alert_Message> {
        byte alert_level;
        byte alert_description;

        public TLS_Alert_Message_Builder() {

        }

        @Override
        public TLS_Alert_Message build() throws Exception {
            return new TLS_Alert_Message(this);
        }

        @Override
        public void fixSizeFields() {
            return;
        }

        @Override
        public int fixAndGetTotalSize() {
            return 1;
        }
    }
}
