package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import java.util.Arrays;

public class TLS_Encrypted_Application_Data extends TLS_Handshake_Sublayer {
    byte[] payload;

    TLS_Encrypted_Application_Data(byte[] raw_data, int start, int len) {
        this.payload = new byte[len];
        System.arraycopy(raw_data, start, this.payload, 0, len);
    }

    @Override
    protected byte[] buildRawData() {
        return Arrays.copyOf(payload, payload.length);
    }

    @Override
    public int getTotalSize() {
        return payload.length;
    }

    public static class TLS_Encrypted_Application_Data_Builder implements TLS_Builder<TLS_Encrypted_Application_Data>{
        byte[] payload;
        public TLS_Encrypted_Application_Data_Builder(byte[] p) {
            this.payload = Arrays.copyOf(p, p.length);
        }

        @Override
        public TLS_Encrypted_Application_Data build() throws Exception {
            if (this.payload != null )
                return new TLS_Encrypted_Application_Data(this.payload, 0, this.payload.length);

            throw new IllegalStateException("Payload cannot be null!");
        }

        @Override
        public void fixSizeFields() {
            return;
        }

        @Override
        public int fixAndGetTotalSize() {
            if (this.payload != null) return this.payload.length;
            return 0;
        }
    }
}
