package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.packet.namednumber.NamedNumber;

import java.util.HashMap;
import java.util.Map;

public final class TLS_Enum_Alert_Description extends NamedNumber<Byte, TLS_Enum_Alert_Description> {
    public TLS_Enum_Alert_Description(Byte value, String name) {
        super(value, name);
    }
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_CLOSE_NOTIFY
            = new TLS_Enum_Alert_Description((byte)0, "ALERT_DESCRIPTION_CLOSE_NOTIFY");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_UNEXPECTED_MESSAGE
            = new TLS_Enum_Alert_Description((byte)10, "ALERT_DESCRIPTION_UNEXPECTED_MESSAGE");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_BAD_RECORD_MAC
            = new TLS_Enum_Alert_Description((byte)20, "ALERT_DESCRIPTION_BAD_RECORD_MAC");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_DECRYPTION_FAILED_RESERVED
            = new TLS_Enum_Alert_Description((byte)21, "ALERT_DESCRIPTION_DECRYPTION_FAILED_RESERVED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_RECORD_OVERFLOW
            = new TLS_Enum_Alert_Description((byte)22, "ALERT_DESCRIPTION_RECORD_OVERFLOW");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_DECOMPRESSION_FAILURE
            = new TLS_Enum_Alert_Description((byte)30, "ALERT_DESCRIPTION_DECOMPRESSION_FAILURE");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_HANDSHAKE_FAILURE
            = new TLS_Enum_Alert_Description((byte)40, "ALERT_DESCRIPTION_HANDSHAKE_FAILURE");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_NO_CERTIFICATE_RESERVED
            = new TLS_Enum_Alert_Description((byte)41, "ALERT_DESCRIPTION_NO_CERTIFICATE_RESERVED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_BAD_CERTIFICATE
            = new TLS_Enum_Alert_Description((byte)42, "ALERT_DESCRIPTION_BAD_CERTIFICATE");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_UNSUPPORTED_CERTIFICATE
            = new TLS_Enum_Alert_Description((byte)43, "ALERT_DESCRIPTION_UNSUPPORTED_CERTIFICATE");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_CERIFICATE_REVOKED
            = new TLS_Enum_Alert_Description((byte)44, "ALERT_DESCRIPTION_CERIFICATE_REVOKED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_CERIFICATE_EXPIRED
            = new TLS_Enum_Alert_Description((byte)45, "ALERT_DESCRIPTION_CERIFICATE_EXPIRED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_CERIFICATE_UNKNOWN
            = new TLS_Enum_Alert_Description((byte)46, "ALERT_DESCRIPTION_CERIFICATE_UNKNOWN");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_ILLEGAL_PARAMETER
            = new TLS_Enum_Alert_Description((byte)47, "ALERT_DESCRIPTION_ILLEGAL_PARAMETER");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_UNKNOWN_CA
            = new TLS_Enum_Alert_Description((byte)48, "ALERT_DESCRIPTION_UNKNOWN_CA");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_ACCESS_DENIED
            = new TLS_Enum_Alert_Description((byte)49, "ALERT_DESCRIPTION_ACCESS_DENIED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_DECODE_ERROR
            = new TLS_Enum_Alert_Description((byte)50, "ALERT_DESCRIPTION_DECODE_ERROR");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_DECRYPT_ERROR
            = new TLS_Enum_Alert_Description((byte)51, "ALERT_DESCRIPTION_DECRYPT_ERROR");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_EXPORT_RESTRICTION_RESERVED
            = new TLS_Enum_Alert_Description((byte)60, "ALERT_DESCRIPTION_EXPORT_RESTRICTION_RESERVED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_PROTOCOL_VERSION
            = new TLS_Enum_Alert_Description((byte)70, "ALERT_DESCRIPTION_PROTOCOL_VERSION");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_INSUFFICIENT_SECURITY
            = new TLS_Enum_Alert_Description((byte)71, "ALERT_DESCRIPTION_INSUFFICIENT_SECURITY");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_INTERNAL_ERROR
            = new TLS_Enum_Alert_Description((byte)80, "ALERT_DESCRIPTION_INTERNAL_ERROR");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_USER_CANCELLED
            = new TLS_Enum_Alert_Description((byte)90, "ALERT_DESCRIPTION_USER_CANCELLED");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_NO_RENEGOTIATION
            = new TLS_Enum_Alert_Description((byte)100, "ALERT_DESCRIPTION_NO_RENEGOTIATION");
    public static final TLS_Enum_Alert_Description ALERT_DESCRIPTION_UNSUPPORTED_EXTENSIONS
            = new TLS_Enum_Alert_Description((byte)110, "ALERT_DESCRIPTION_UNSUPPORTED_EXTENSIONS");



    private static final Map<Byte, TLS_Enum_Alert_Description> registry
            = new HashMap<Byte, TLS_Enum_Alert_Description>();

    static {
        registry.put(ALERT_DESCRIPTION_CLOSE_NOTIFY.value(), ALERT_DESCRIPTION_CLOSE_NOTIFY);
        registry.put(ALERT_DESCRIPTION_UNEXPECTED_MESSAGE.value(), ALERT_DESCRIPTION_UNEXPECTED_MESSAGE);
        registry.put(ALERT_DESCRIPTION_BAD_RECORD_MAC.value(), ALERT_DESCRIPTION_BAD_RECORD_MAC);
        registry.put(ALERT_DESCRIPTION_DECRYPTION_FAILED_RESERVED.value(), ALERT_DESCRIPTION_DECRYPTION_FAILED_RESERVED);
        registry.put(ALERT_DESCRIPTION_RECORD_OVERFLOW.value(), ALERT_DESCRIPTION_RECORD_OVERFLOW);
        registry.put(ALERT_DESCRIPTION_DECOMPRESSION_FAILURE.value(), ALERT_DESCRIPTION_DECOMPRESSION_FAILURE);
        registry.put(ALERT_DESCRIPTION_HANDSHAKE_FAILURE.value(), ALERT_DESCRIPTION_HANDSHAKE_FAILURE);
        registry.put(ALERT_DESCRIPTION_NO_CERTIFICATE_RESERVED.value(), ALERT_DESCRIPTION_NO_CERTIFICATE_RESERVED);
        registry.put(ALERT_DESCRIPTION_BAD_CERTIFICATE.value(), ALERT_DESCRIPTION_BAD_CERTIFICATE);
        registry.put(ALERT_DESCRIPTION_UNSUPPORTED_CERTIFICATE.value(), ALERT_DESCRIPTION_UNSUPPORTED_CERTIFICATE);
        registry.put(ALERT_DESCRIPTION_CERIFICATE_REVOKED.value(), ALERT_DESCRIPTION_CERIFICATE_REVOKED);
        registry.put(ALERT_DESCRIPTION_CERIFICATE_EXPIRED.value(), ALERT_DESCRIPTION_CERIFICATE_EXPIRED);
        registry.put(ALERT_DESCRIPTION_CERIFICATE_UNKNOWN.value(), ALERT_DESCRIPTION_CERIFICATE_UNKNOWN);
        registry.put(ALERT_DESCRIPTION_ILLEGAL_PARAMETER.value(), ALERT_DESCRIPTION_ILLEGAL_PARAMETER);
        registry.put(ALERT_DESCRIPTION_UNKNOWN_CA.value(), ALERT_DESCRIPTION_UNKNOWN_CA);
        registry.put(ALERT_DESCRIPTION_ACCESS_DENIED.value(), ALERT_DESCRIPTION_ACCESS_DENIED);
        registry.put(ALERT_DESCRIPTION_DECODE_ERROR.value(), ALERT_DESCRIPTION_DECODE_ERROR);
        registry.put(ALERT_DESCRIPTION_DECRYPT_ERROR.value(), ALERT_DESCRIPTION_DECRYPT_ERROR);
        registry.put(ALERT_DESCRIPTION_EXPORT_RESTRICTION_RESERVED.value(), ALERT_DESCRIPTION_EXPORT_RESTRICTION_RESERVED);
        registry.put(ALERT_DESCRIPTION_PROTOCOL_VERSION.value(), ALERT_DESCRIPTION_PROTOCOL_VERSION);
        registry.put(ALERT_DESCRIPTION_INSUFFICIENT_SECURITY.value(), ALERT_DESCRIPTION_INSUFFICIENT_SECURITY);
        registry.put(ALERT_DESCRIPTION_INTERNAL_ERROR.value(), ALERT_DESCRIPTION_INTERNAL_ERROR);
        registry.put(ALERT_DESCRIPTION_USER_CANCELLED.value(), ALERT_DESCRIPTION_USER_CANCELLED);
        registry.put(ALERT_DESCRIPTION_NO_RENEGOTIATION.value(), ALERT_DESCRIPTION_NO_RENEGOTIATION);
        registry.put(ALERT_DESCRIPTION_UNSUPPORTED_EXTENSIONS.value(), ALERT_DESCRIPTION_UNSUPPORTED_EXTENSIONS);

    }

    @Override
    public int compareTo(TLS_Enum_Alert_Description o) {
        return this.value().compareTo(o.value());
    }

    public static TLS_Enum_Alert_Description getInstance(Byte value) {
        if (registry.containsKey(value)) {
            return registry.get(value);
        }
        else {
            return new TLS_Enum_Alert_Description(value, "unknown");
        }
    }
}
