package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.packet.namednumber.NamedNumber;

import java.util.HashMap;
import java.util.Map;

public final class TLS_Enum_Content_Type extends NamedNumber<Byte, TLS_Enum_Content_Type> {
    public TLS_Enum_Content_Type(Byte value, String name) {
        super(value, name);
    }
    public static final TLS_Enum_Content_Type RECORD_LAYER_CONTENT_TYPE_CHANGE_CYPHER_SPEC
            = new TLS_Enum_Content_Type((byte)20, "RECORD_LAYER_CONTENT_TYPE_CHANGE_CYPHER_SPEC");

    public static final TLS_Enum_Content_Type RECORD_LAYER_CONTENT_TYPE_ALERT
            = new TLS_Enum_Content_Type((byte)21, "RECORD_LAYER_CONTENT_TYPE_ALERT");

    public static final TLS_Enum_Content_Type RECORD_LAYER_CONTENT_TYPE_HANDSHAKE
            = new TLS_Enum_Content_Type((byte) 22, "RECORD_LAYER_CONTENT_TYPE_HANDSHAKE");

    public static final TLS_Enum_Content_Type RECORD_LAYER_CONTENT_TYPE_APPLICATION_DATA
            = new TLS_Enum_Content_Type((byte)23, "RECORD_LAYER_CONTENT_TYPE_APPLICATION_DATA");


    private static final Map<Byte, TLS_Enum_Content_Type> registry
            = new HashMap<Byte, TLS_Enum_Content_Type>();

    static {
        registry.put(RECORD_LAYER_CONTENT_TYPE_CHANGE_CYPHER_SPEC.value(), RECORD_LAYER_CONTENT_TYPE_CHANGE_CYPHER_SPEC);
        registry.put(RECORD_LAYER_CONTENT_TYPE_HANDSHAKE.value(), RECORD_LAYER_CONTENT_TYPE_HANDSHAKE);
        registry.put(RECORD_LAYER_CONTENT_TYPE_APPLICATION_DATA.value(), RECORD_LAYER_CONTENT_TYPE_APPLICATION_DATA);
    }
    @Override
    public int compareTo(TLS_Enum_Content_Type o) {
        return this.value().compareTo(o.value());
    }

    public static TLS_Enum_Content_Type getInstance(Byte value) {
        if (registry.containsKey(value)) {
            return registry.get(value);
        }
        else {
            return new TLS_Enum_Content_Type(value, "unknown");
        }
    }
}
