package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.packet.namednumber.NamedNumber;

import java.util.HashMap;
import java.util.Map;

public final class TLS_Enum_Handshake_Type extends NamedNumber<Byte, TLS_Enum_Handshake_Type> {
    public TLS_Enum_Handshake_Type(Byte value, String name) {
        super(value, name);
    }


    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_CLIENT_HELLO
            = new TLS_Enum_Handshake_Type((byte)1, "SUBLAYER_HANDSHAKE_TYPE_CLIENT_HELLO");
    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO
            = new TLS_Enum_Handshake_Type((byte)2, "SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO");

    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_CERTIFICATE
            = new TLS_Enum_Handshake_Type((byte)11, "SUBLAYER_HANDSHAKE_TYPE_CERTIFICATE");
    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_SERVER_KEY_EXCHANGE
            = new TLS_Enum_Handshake_Type((byte)12, "SUBLAYER_HANDSHAKE_TYPE_SERVER_KEY_EXCHANGE");

    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO_DONE
            = new TLS_Enum_Handshake_Type((byte)14, "SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO_DONE");
    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_CLIENT_KEY_EXCHANGE
            = new TLS_Enum_Handshake_Type((byte)16, "SUBLAYER_HANDSHAKE_TYPE_CLIENT_KEY_EXCHANGE");

    public static final TLS_Enum_Handshake_Type SUBLAYER_HANDSHAKE_TYPE_FINISHED
            = new TLS_Enum_Handshake_Type((byte)20, "SUBLAYER_HANDSHAKE_TYPE_FINISHED");

    private static final Map<Byte, TLS_Enum_Handshake_Type> registry
            = new HashMap<Byte, TLS_Enum_Handshake_Type>();

    static {
        registry.put(SUBLAYER_HANDSHAKE_TYPE_CLIENT_HELLO.value(), SUBLAYER_HANDSHAKE_TYPE_CLIENT_HELLO);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO.value(), SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_CERTIFICATE.value(), SUBLAYER_HANDSHAKE_TYPE_CERTIFICATE);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_SERVER_KEY_EXCHANGE.value(), SUBLAYER_HANDSHAKE_TYPE_SERVER_KEY_EXCHANGE);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO_DONE.value(), SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO_DONE);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_CLIENT_KEY_EXCHANGE.value(), SUBLAYER_HANDSHAKE_TYPE_CLIENT_KEY_EXCHANGE);
        registry.put(SUBLAYER_HANDSHAKE_TYPE_FINISHED.value(), SUBLAYER_HANDSHAKE_TYPE_FINISHED);

    }
    @Override
    public int compareTo(TLS_Enum_Handshake_Type o) {
        return this.value().compareTo(o.value());
    }

    public static TLS_Enum_Handshake_Type getInstance(Byte value) {
        if (registry.containsKey(value)) {
            return registry.get(value);
        }
        else {
            return new TLS_Enum_Handshake_Type(value, "unknown");
        }
    }
}
