package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_Extension_EC_POINT_FORMATS extends TLS_Handshake_Extension_Abstract{
    byte point_formats_length;
    byte[] point_formats;

    TLS_Handshake_Extension_EC_POINT_FORMATS(TLS_Handshake_Extension_EC_POINT_FORMATS_Builder b) {
        super(b);

        this.point_formats_length = b.point_formats_length;
        this.point_formats = new byte[b.point_formats.length];
        System.arraycopy(b.point_formats, 0, this.point_formats, 0, this.point_formats.length);
    }

    TLS_Handshake_Extension_EC_POINT_FORMATS(byte[] raw_data, int start) {
        super(raw_data, start);

        int actual_point_formats_length = SSL_Helper.castToInt(raw_data[start + 4]);
        point_formats_length = raw_data[start + 4];
        if (actual_point_formats_length > 0) {
            point_formats = new byte[actual_point_formats_length];
            System.arraycopy(raw_data, start + 5, point_formats, 0, actual_point_formats_length);
        }
    }

    @Override
    byte[] buildRawData() {
        byte[] rd = new byte[getTotalSize()];
        SSL_Helper.revert_to_bytes(SSL_Helper.castToInt(super.type), rd, 0, 2);
        SSL_Helper.revert_to_bytes(SSL_Helper.castToInt(super.length), rd, 2, 2);
        rd[4] = point_formats_length;
        if (point_formats.length > 0) {
            System.arraycopy(point_formats, 0, rd, 5, point_formats.length);
        }
        return rd;
    }

    public static class TLS_Handshake_Extension_EC_POINT_FORMATS_Builder extends TLS_Handshake_Extension_Abstract_Builder {
        byte point_formats_length;
        byte[] point_formats;

        TLS_Handshake_Extension_EC_POINT_FORMATS_Builder(TLS_Handshake_Extension_EC_POINT_FORMATS o) {
            super(o);

            this.point_formats_length = o.point_formats_length;
            this.point_formats = new byte[o.point_formats.length];
            System.arraycopy(o.point_formats, 0, this.point_formats, 0, this.point_formats.length);
        }

        public TLS_Handshake_Extension_EC_POINT_FORMATS_Builder(byte[] rd, int start) {
            super(rd, start);

            this.point_formats_length = rd[start + 4];
            this.point_formats = new byte[SSL_Helper.castToInt(point_formats_length)];
            System.arraycopy(rd, 5, this.point_formats, 0, this.point_formats.length);
        }
        @Override
        public TLS_Handshake_Extension_EC_POINT_FORMATS build() {
            return new TLS_Handshake_Extension_EC_POINT_FORMATS(this);
        }

        @Override
        public void fixSizeFields() {
            point_formats_length = (byte) point_formats.length;
            super.length = (short) (point_formats.length + 1);
        }

    }
}
