package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_Extension_Unknown extends TLS_Handshake_Extension_Abstract{
   byte[] data;

    TLS_Handshake_Extension_Unknown(TLS_Handshake_Extension_Unknown_Builder b) {
        super(b);

        if (SSL_Helper.castToInt(b.length) > 0) {
            this.data = new byte[b.data.length];
            System.arraycopy(b.data, 0, this.data, 0, this.data.length);
        }
    }

    TLS_Handshake_Extension_Unknown(byte[] raw_data, int start) {
        super(raw_data, start);

        int len = SSL_Helper.castToInt(super.length);
        if (len > 0) {
            data = new byte[len];
            System.arraycopy(raw_data, start + 4, data, 0, len);
        }
    }

    @Override
    byte[] buildRawData() {
        byte[] rd = new byte[getTotalSize()];
        SSL_Helper.revert_to_bytes(SSL_Helper.castToInt(super.type), rd, 0, 2);
        SSL_Helper.revert_to_bytes(SSL_Helper.castToInt(super.length), rd, 2, 2);
        if (SSL_Helper.castToInt(super.length) > 0) {
            System.arraycopy(data, 0, rd, 4, data.length);
        }
        return rd;
    }

    public static class TLS_Handshake_Extension_Unknown_Builder extends TLS_Handshake_Extension_Abstract_Builder{
        byte[] data;

        TLS_Handshake_Extension_Unknown_Builder(TLS_Handshake_Extension_Unknown o) {
            super(o);

            if (SSL_Helper.castToInt(o.length) > 0) {
                this.data = new byte[o.data.length];
                System.arraycopy(o.data, 0, this.data, 0, this.data.length);
            }
        }

        public TLS_Handshake_Extension_Unknown_Builder(byte[] rd, int start) {
            super(rd, start);

            if (SSL_Helper.castToInt(super.length) > 0) {
                this.data = new byte[SSL_Helper.castToInt(super.length)];
                System.arraycopy(rd, start + 4, this.data, 0, this.data.length);
            }
        }

        @Override
        public TLS_Handshake_Extension_Unknown build() {
            return new TLS_Handshake_Extension_Unknown(this);
        }

        @Override
        public void fixSizeFields() {
            if (this.data == null) {
                super.length = 0;
            } else {
                super.length = (short) this.data.length;
            }
        }

    }

}
