package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import java.io.Serializable;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_Random_Component_Subclass implements Serializable {
    byte[] GMT_time;
    byte[] random_bytes;

    TLS_Handshake_Random_Component_Subclass() {
        GMT_time = new byte[4];
        SSL_Helper.revert_to_bytes((int) (System.currentTimeMillis() / 1000), GMT_time, 0, 4);
    }

    TLS_Handshake_Random_Component_Subclass(TLS_Handshake_Random_Component_Subclass_Builder b) {
        this.GMT_time = new byte[b.GMT_time.length];
        this.random_bytes = new byte[b.random_bytes.length];

        System.arraycopy(b.GMT_time, 0, this.GMT_time, 0, this.GMT_time.length);
        System.arraycopy(b.random_bytes, 0, this.random_bytes, 0, this.random_bytes.length);
    }


    TLS_Handshake_Random_Component_Subclass(byte[] raw_bytes, int start) {
        GMT_time = new byte[4];
        System.arraycopy(raw_bytes, start, GMT_time, 0, 4);

        random_bytes = new byte[28];
        System.arraycopy(raw_bytes, start + 4, random_bytes, 0, 28);
    }

    public int s_getTotalSize() {
        return  32;
    }

    public byte[] s_getRawData() {
        byte[] rd = new byte[s_getTotalSize()];
        System.arraycopy(this.GMT_time, 0, rd, 0, this.GMT_time.length);
        System.arraycopy(this.random_bytes, 0, rd, this.GMT_time.length, this.random_bytes.length);

        return rd;
    }

    public static class TLS_Handshake_Random_Component_Subclass_Builder implements TLS_Builder<TLS_Handshake_Random_Component_Subclass> {
        public byte[] GMT_time;
        public byte[] random_bytes;

        public TLS_Handshake_Random_Component_Subclass_Builder(TLS_Handshake_Random_Component_Subclass o) {
            this.GMT_time = new byte[o.GMT_time.length];
            this.random_bytes = new byte[o.random_bytes.length];

            System.arraycopy(o.GMT_time, 0, this.GMT_time, 0, this.GMT_time.length);
            System.arraycopy(o.random_bytes, 0, this.random_bytes, 0, this.random_bytes.length);
        }

        @Override
        public TLS_Handshake_Random_Component_Subclass build() throws Exception {
            return new TLS_Handshake_Random_Component_Subclass(this);
        }

        @Override
        public void fixSizeFields() {
            if(GMT_time == null) {
                GMT_time = new byte[4];
            }
            if(random_bytes==null) {
                random_bytes = new byte[28];
            }
        }

        @Override
        public int fixAndGetTotalSize() {
            fixSizeFields();
            return this.GMT_time.length + this.random_bytes.length;
        }
    }
}