package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_Server_Hello_Done extends TLS_Handshake_Sublayer {
    byte handshake_type;
    byte[] length;

    TLS_Handshake_Server_Hello_Done(TLS_Handshake_Server_Hello_Done_Builder b)  {
        this.handshake_type = b.handshake_type;
        this.length = new byte[b.length.length];

        System.arraycopy(b.length, 0, this.length, 0, this.length.length);
    }


    TLS_Handshake_Server_Hello_Done(byte[] raw_data, int start) {
        handshake_type = raw_data[start];
        length = new byte[3];
        System.arraycopy(raw_data, start+1, length, 0, 3);
    }

    @Override
    protected byte[] buildRawData() {
        byte[] rd = new byte[4];
        rd[0] = handshake_type;
        System.arraycopy(length, 0, rd, 1, 3);
        return rd;
    }

    @Override
    public int getTotalSize() {
        return 1 + length.length + SSL_Helper.convert_to_int(length, 0, 3);
    }

    public static class TLS_Handshake_Server_Hello_Done_Builder implements TLS_Builder<TLS_Handshake_Server_Hello_Done> {
        byte handshake_type;
        byte[] length;

        TLS_Handshake_Server_Hello_Done_Builder(TLS_Handshake_Server_Hello_Done o)  {
            this.handshake_type = o.handshake_type;
            this.length = new byte[o.length.length];

            System.arraycopy(o.length, 0, this.length, 0, this.length.length);
        }

        @Override
        public TLS_Handshake_Server_Hello_Done build() throws Exception {
            return new TLS_Handshake_Server_Hello_Done(this);
        }

        @Override
        public void fixSizeFields() {
            if (this.length == null) {
                this.length = new byte[3];
            }

            SSL_Helper.revert_to_bytes(0, this.length, 0, this.length.length);
        }

        @Override
        public int fixAndGetTotalSize() {
            fixSizeFields();
            return  SSL_Helper.convert_to_int(this.length, 0, this.length.length) + this.length.length + 1;
        }
    }

}
