package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import java.io.Serializable;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_SessionID_Subclass implements Serializable {
    byte session_ID_len;
    byte[] sessionID;

    TLS_Handshake_SessionID_Subclass(TLS_Handshake_SessionID_Subclass_Builder b) {
        this.session_ID_len = b.session_ID_len;
        this.sessionID = new byte[b.sessionID.length];

        System.arraycopy(b.sessionID, 0, this.sessionID, 0, this.sessionID.length);
    }

    TLS_Handshake_SessionID_Subclass(byte[] raw_data, int start) {
        session_ID_len = raw_data[start];
        if (SSL_Helper.castToInt(session_ID_len) > 0) {
            sessionID = new byte[SSL_Helper.castToInt(session_ID_len)];
            System.arraycopy(raw_data, start+1, sessionID, 0, sessionID.length);
        }
    }

    int s_getTotalSize() {
        return 1 + session_ID_len;
    }

    public static class TLS_Handshake_SessionID_Subclass_Builder implements TLS_Builder<TLS_Handshake_SessionID_Subclass> {
        public byte session_ID_len;
        public byte[] sessionID;

        TLS_Handshake_SessionID_Subclass_Builder(TLS_Handshake_SessionID_Subclass o) {
            this.session_ID_len = o.session_ID_len;
            this.sessionID = new byte[o.sessionID.length];

            System.arraycopy(o.sessionID, 0, this.sessionID, 0, this.sessionID.length);
        }

        @Override
        public TLS_Handshake_SessionID_Subclass build() throws Exception {
            return new TLS_Handshake_SessionID_Subclass(this);
        }

        @Override
        public void fixSizeFields() {
            session_ID_len = (byte) this.sessionID.length;
        }

        @Override
        public int fixAndGetTotalSize() {
            fixSizeFields();
            return SSL_Helper.castToInt(session_ID_len) + 1;
        }
    }
}