package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.util.LazyValue;

public abstract class TLS_Handshake_Sublayer implements TLS_Sublayer {
    protected final LazyValue<byte[]> rawDataCache;

    public TLS_Handshake_Sublayer(){
        rawDataCache = new LazyValue<byte[]>(
                new LazyValue.BuildValueCommand<byte[]>() {
                    @Override
                    public byte[] buildValue() {
                        return buildRawData();
                    }
                }
        );;
    }

    protected abstract byte[] buildRawData();

    public final byte[] getRawData() {
        byte[] rawData = rawDataCache.getValue();

        byte[] copy = new byte[rawData.length];
        System.arraycopy(rawData, 0, copy, 0, copy.length);
        return copy;
    }
    public abstract int getTotalSize();

    public static class TLS_Handshake_Sublayer_Builder_Factory implements TLS_Sublayer_Builder_Factory {

        @Override
        public TLS_Builder build(TLS_Sublayer s) {
            if (s.getClass() == TLS_Handshake_Server_Hello.class) {
                return new TLS_Handshake_Server_Hello.TLS_Handshake_Server_Hello_Builder((TLS_Handshake_Server_Hello) s);
            } else if (s.getClass() == TLS_Handshake_Certificate.class) {
                return new TLS_Handshake_Certificate.TLS_Handshake_Certificate_Builder((TLS_Handshake_Certificate)s);
            } else if (s.getClass() == TLS_Handshake_Server_Key_Exchange.class) {
                return new TLS_Handshake_Server_Key_Exchange.TLS_Handshake_Server_Key_Exchange_Builder((TLS_Handshake_Server_Key_Exchange) s);
            } else if (s.getClass() == TLS_Handshake_Server_Hello_Done.class){
                return new TLS_Handshake_Server_Hello_Done.TLS_Handshake_Server_Hello_Done_Builder((TLS_Handshake_Server_Hello_Done) s);
            }
            else {
                return null;
            }
        }
    }
}
