package edu.wpi.appjudicator.ssl.tls_packet_parsing;

public class TLS_Handshake_Sublayer_Factory implements TLS_Sublayer_Factory {
    public TLS_Handshake_Sublayer build(byte[] raw_data, int start, int length) {
        TLS_Enum_Handshake_Type handshake_type = TLS_Enum_Handshake_Type.getInstance(raw_data[start]);

        if (handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_CLIENT_HELLO)) {
            return new TLS_Handshake_Client_Hello(raw_data, start);
        } else if ((handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO))) {
            return new TLS_Handshake_Server_Hello(raw_data, start);
        } else if ((handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_CERTIFICATE))) {
            return new TLS_Handshake_Certificate(raw_data, start);
        } else if ((handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_SERVER_KEY_EXCHANGE))) {
            return new TLS_Handshake_Server_Key_Exchange(raw_data, start);
        } else if ((handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_SERVER_HELLO_DONE))) {
            return new TLS_Handshake_Server_Hello_Done(raw_data, start);
        } else if ((handshake_type.equals(TLS_Enum_Handshake_Type.SUBLAYER_HANDSHAKE_TYPE_CLIENT_KEY_EXCHANGE))) {
            return new TLS_Handshake_Client_Key_Exchange(raw_data, start);
        } else {
            return new TLS_Handshake_Encrypted_Message(raw_data, start, length);
        }
    }

}
