package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import java.util.LinkedList;
import java.util.List;

public class TLS_List_Builder<T> {
    List<TLS_Builder<T>> list;

    public TLS_List_Builder() {
        this.list = new LinkedList<TLS_Builder<T>>();
    }

    TLS_List_Builder(List<TLS_Builder<T>> list) {
        this.list = new LinkedList<TLS_Builder<T>>(list);
    }

    TLS_List_Builder(TLS_List_Builder<T> b) {
        this.list = new LinkedList<TLS_Builder<T>>(b.list);
    }

    public void add(TLS_Builder<T> l) {
        this.list.add(l);
    }

    void add(TLS_Builder<T> l, int idx) {
        this.list.add(idx, l);
    }

    void remove() {
        this.list.remove(this.list.size() - 1);
    }

    void remove(int idx) {
        this.list.remove(idx);
    }

    void remove(T o) {
        this.list.remove(o);
    }

    public TLS_Builder<T> get(int idx) {
        return list.get(idx);
    }

    TLS_Builder<T> get() {
        return list.get(list.size() - 1);
    }

    List<T> build() throws Exception{
        if (this.list == null || this.list.size() == 0){
            throw new Exception("List is empty or null");
        }

        LinkedList<T> returnList = new LinkedList<T>();
        for (TLS_Builder<T> b : list) {
            returnList.add(b.build());
        }
        return returnList;
    }

    void fixLengths() {
        for (TLS_Builder<T> b : list) {
            b.fixSizeFields();
        }
    }

    int getTotalSize() {
        int total = 0;
        for (TLS_Builder<T> b : list) {
            total += b.fixAndGetTotalSize();
        }

        return total;
    }

    int fixLengthsAndGetTotalSize() {
        int total = 0;
        for (TLS_Builder<T> b : list) {
            b.fixSizeFields();
            total += b.fixAndGetTotalSize();
        }

        return total;
    }
}
